From 0c3dbbefd281377d7eb100aa88e20866d9268be1 Mon Sep 17 00:00:00 2001
From: Timur Pocheptsov <timur.pocheptsov@qt.io>
Date: Mon, 2 Nov 2020 14:37:46 +0100
Subject: [PATCH 113/262] Network self-test: make it work with
 docker/containers
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Also, removed the part that was testing the deprecated
(and later deleted in Qt 6) API.

Fixes: QTBUG-87740
Change-Id: Idfe73708784774188afd40048f81406aa720a554
Reviewed-by: Mårten Nordheim <marten.nordheim@qt.io>
(cherry picked from commit 4f6c5d83d09881a8432873487eab44b88eabec9e)
---
 tests/auto/network-settings.h                 |  38 +-
 .../other/networkselftest/networkselftest.pro |   3 +
 .../networkselftest/tst_networkselftest.cpp   | 236 +++--
 tests/testserver/apache2/testdata/main.conf   |   4 +
 .../testdata/www/htdocs/protected/rfc3252.txt | 899 ++++++++++++++++++
 .../htdocs/qxmlquery/completelyEmptyQuery.xq  |   0
 .../www/htdocs/qxmlquery/notWellformed.xml    |   1 +
 .../qxmlquery/notWellformedViaHttps.xml       |   1 +
 .../testdata/www/htdocs/qxmlquery/viaHttp.xq  |   1 +
 .../www/htdocs/qxmlquery/wellFormed.xml       |   2 +
 .../htdocs/qxmlquery/wellFormedViaHttps.xml   |   2 +
 .../vsftpd/testdata/ftp/pub/qxmlquery/README  |   1 +
 .../ftp/pub/qxmlquery/completelyEmptyQuery.xq |   0
 .../ftp/pub/qxmlquery/notWellFormed.xml       |   1 +
 .../testdata/ftp/pub/qxmlquery/viaFtp.xq      |   1 +
 .../testdata/ftp/pub/qxmlquery/wellFormed.xml |   2 +
 16 files changed, 1094 insertions(+), 98 deletions(-)
 create mode 100644 tests/testserver/apache2/testdata/www/htdocs/protected/rfc3252.txt
 create mode 100644 tests/testserver/apache2/testdata/www/htdocs/qxmlquery/completelyEmptyQuery.xq
 create mode 100644 tests/testserver/apache2/testdata/www/htdocs/qxmlquery/notWellformed.xml
 create mode 100644 tests/testserver/apache2/testdata/www/htdocs/qxmlquery/notWellformedViaHttps.xml
 create mode 100644 tests/testserver/apache2/testdata/www/htdocs/qxmlquery/viaHttp.xq
 create mode 100644 tests/testserver/apache2/testdata/www/htdocs/qxmlquery/wellFormed.xml
 create mode 100644 tests/testserver/apache2/testdata/www/htdocs/qxmlquery/wellFormedViaHttps.xml
 create mode 100644 tests/testserver/vsftpd/testdata/ftp/pub/qxmlquery/README
 create mode 100644 tests/testserver/vsftpd/testdata/ftp/pub/qxmlquery/completelyEmptyQuery.xq
 create mode 100644 tests/testserver/vsftpd/testdata/ftp/pub/qxmlquery/notWellFormed.xml
 create mode 100644 tests/testserver/vsftpd/testdata/ftp/pub/qxmlquery/viaFtp.xq
 create mode 100644 tests/testserver/vsftpd/testdata/ftp/pub/qxmlquery/wellFormed.xml

diff --git a/tests/auto/network-settings.h b/tests/auto/network-settings.h
index 4dd6ce897b..fc7b1d090e 100644
--- a/tests/auto/network-settings.h
+++ b/tests/auto/network-settings.h
@@ -262,6 +262,41 @@ public:
 #endif
     }
 
+    static QString hostWithServiceOnPort(int port)
+    {
+#if !defined(QT_TEST_SERVER)
+        Q_UNUSED(port);
+        return serverName();
+#else
+        switch (port) {
+        case 13:
+        case 22:
+        case 139:
+            return serverName(); // No such things in docker (yet?)
+        case 7:
+            return echoServerName();
+        case 21:
+            return ftpServerName();
+        case 80:
+        case 443:
+            return httpServerName();
+        case 143:
+            return imapServerName();
+        case 3128:
+        case 3129:
+        case 3130:
+            return httpProxyServerName();
+        case 1080:
+        case 1081:
+            return socksProxyServerName();
+        case 2121:
+            return ftpProxyServerName();
+        default:
+            return serverName();
+        }
+#endif // QT_TEST_SERVER
+    }
+
 #ifdef QT_NETWORK_LIB
     static QHostAddress imapServerIp()
     {
@@ -297,5 +332,6 @@ public:
     {
         return getServerIpImpl(firewallServerName());
     }
-#endif
+
+#endif // QT_NETWORK_LIB
 };
diff --git a/tests/auto/other/networkselftest/networkselftest.pro b/tests/auto/other/networkselftest/networkselftest.pro
index 7c307a097b..ea81b10f8c 100644
--- a/tests/auto/other/networkselftest/networkselftest.pro
+++ b/tests/auto/other/networkselftest/networkselftest.pro
@@ -3,3 +3,6 @@ TARGET = tst_networkselftest
 
 SOURCES += tst_networkselftest.cpp
 QT = core core-private network testlib
+
+CONFIG += unsupported/testserver
+QT_TEST_SERVER_LIST = cyrus vsftpd apache2 ftp-proxy danted squid echo
diff --git a/tests/auto/other/networkselftest/tst_networkselftest.cpp b/tests/auto/other/networkselftest/tst_networkselftest.cpp
index 396e23da0c..b875c7c5cf 100644
--- a/tests/auto/other/networkselftest/tst_networkselftest.cpp
+++ b/tests/auto/other/networkselftest/tst_networkselftest.cpp
@@ -35,18 +35,16 @@
 #include <QtCore/QStandardPaths>
 #include <QtCore/private/qiodevice_p.h>
 
-#ifndef QT_NO_BEARERMANAGEMENT
-#include <QtNetwork/qnetworkconfigmanager.h>
-#include <QtNetwork/qnetworkconfiguration.h>
-#include <QtNetwork/qnetworksession.h>
-#endif
-
 #include "../../network-settings.h"
 
 class tst_NetworkSelfTest: public QObject
 {
     Q_OBJECT
+    // This is either old server's address, or the new http
+    // server's address (different from ftp, for example):
     QHostAddress cachedIpAddress;
+    // This is only for the new docker test server:
+    QHostAddress ftpServerIpAddress;
 public:
     tst_NetworkSelfTest();
     virtual ~tst_NetworkSelfTest();
@@ -83,12 +81,6 @@ private slots:
 
     // ssl supported test
     void supportsSsl();
-private:
-#ifndef QT_NO_BEARERMANAGEMENT
-    QNetworkConfigurationManager *netConfMan;
-    QNetworkConfiguration networkConfiguration;
-    QScopedPointer<QNetworkSession> networkSession;
-#endif
 };
 
 class Chat
@@ -223,8 +215,8 @@ static void netChat(int port, const QList<Chat> &chat)
 #else
     QTcpSocket socket;
 #endif
-
-    socket.connectToHost(QtNetworkSettings::serverName(), port);
+    const auto serverName = QtNetworkSettings::hostWithServiceOnPort(port);
+    socket.connectToHost(serverName, port);
     qDebug() << 0 << "Connecting to server on port" << port;
     QVERIFY2(socket.waitForConnected(10000),
              QString("Failed to connect to server in step 0: %1").arg(socket.errorString()).toLocal8Bit());
@@ -236,7 +228,7 @@ static void netChat(int port, const QList<Chat> &chat)
             case Chat::Expect: {
                     qDebug() << i << "Expecting" << prettyByteArray(it->data);
                     if (!doSocketRead(&socket, it->data.length(), 3 * defaultReadTimeoutMS))
-                        QFAIL(msgDoSocketReadFailed(QtNetworkSettings::serverName(), port, i, it->data.length()));
+                        QFAIL(msgDoSocketReadFailed(serverName, port, i, it->data.length()));
 
                     // pop that many bytes off the socket
                     QByteArray received = socket.read(it->data.length());
@@ -254,7 +246,7 @@ static void netChat(int port, const QList<Chat> &chat)
                 while (true) {
                     // scan the buffer until we have our string
                     if (!doSocketRead(&socket, it->data.length()))
-                        QFAIL(msgDoSocketReadFailed(QtNetworkSettings::serverName(), port, i, it->data.length()));
+                        QFAIL(msgDoSocketReadFailed(serverName, port, i, it->data.length()));
 
                     QByteArray buffer;
                     buffer.resize(socket.bytesAvailable());
@@ -275,7 +267,7 @@ static void netChat(int port, const QList<Chat> &chat)
             case Chat::SkipBytes: {
                     qDebug() << i << "Skipping" << it->value << "bytes";
                     if (!doSocketRead(&socket, it->value))
-                        QFAIL(msgDoSocketReadFailed(QtNetworkSettings::serverName(), port, i, it->value));
+                        QFAIL(msgDoSocketReadFailed(serverName, port, i, it->value));
 
                     // now discard the bytes
                     QByteArray buffer = socket.read(it->value);
@@ -324,7 +316,7 @@ static void netChat(int port, const QList<Chat> &chat)
 
             case Chat::Reconnect:
                 qDebug() << i << "Reconnecting to server on port" << port;
-                socket.connectToHost(QtNetworkSettings::serverName(), port);
+                socket.connectToHost(serverName, port);
                 QVERIFY2(socket.waitForConnected(10000),
                          QString("Failed to reconnect to server in step %1: %2").arg(i).arg(socket.errorString()).toLocal8Bit());
                 break;
@@ -357,7 +349,7 @@ QHostAddress tst_NetworkSelfTest::serverIpAddress()
 {
     if (cachedIpAddress.protocol() == QAbstractSocket::UnknownNetworkLayerProtocol) {
         // need resolving
-        QHostInfo resolved = QHostInfo::fromName(QtNetworkSettings::serverName());
+        QHostInfo resolved = QHostInfo::fromName(QtNetworkSettings::httpServerName());
         if(resolved.error() != QHostInfo::NoError ||
             resolved.addresses().isEmpty()) {
             qWarning("QHostInfo::fromName failed (%d).", resolved.error());
@@ -370,16 +362,27 @@ QHostAddress tst_NetworkSelfTest::serverIpAddress()
 
 void tst_NetworkSelfTest::initTestCase()
 {
+#if defined(QT_TEST_SERVER)
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::echoServerName(), 7));
+    // TODO: 'daytime' , port 13.
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::ftpServerName(), 21));
+    const QHostInfo resolved = QHostInfo::fromName(QtNetworkSettings::ftpServerName());
+    if (resolved.error() == QHostInfo::NoError && !resolved.addresses().isEmpty())
+        ftpServerIpAddress = resolved.addresses().first();
+    // TODO: 'ssh', port 22.
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::ftpProxyServerName(), 2121));
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::httpServerName(), 80));
+    // TODO: 'smb', port 139.
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::imapServerName(), 143));
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::httpServerName(), 443));
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::httpProxyServerName(), 3128));
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::httpProxyServerName(), 3129));
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::httpProxyServerName(), 3130));
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::socksProxyServerName(), 1080));
+    QVERIFY(QtNetworkSettings::verifyConnection(QtNetworkSettings::socksProxyServerName(), 1081));
+#else
     if (!QtNetworkSettings::verifyTestNetworkSettings())
         QSKIP("No network test server available");
-#ifndef QT_NO_BEARERMANAGEMENT
-    netConfMan = new QNetworkConfigurationManager(this);
-    networkConfiguration = netConfMan->defaultConfiguration();
-    networkSession.reset(new QNetworkSession(networkConfiguration));
-    if (!networkSession->isOpen()) {
-        networkSession->open();
-        QVERIFY(networkSession->waitForOpened(30000));
-    }
 #endif
 }
 
@@ -402,7 +405,7 @@ void tst_NetworkSelfTest::dnsResolution_data()
 {
     QTest::addColumn<QString>("hostName");
     QTest::newRow("local-name") << QtNetworkSettings::serverLocalName();
-    QTest::newRow("fqdn") << QtNetworkSettings::serverName();
+    QTest::newRow("fqdn") << QtNetworkSettings::httpServerName();
 }
 
 void tst_NetworkSelfTest::dnsResolution()
@@ -420,7 +423,7 @@ void tst_NetworkSelfTest::serverReachability()
 {
     // check that we get a proper error connecting to port 12346
     QTcpSocket socket;
-    socket.connectToHost(QtNetworkSettings::serverName(), 12346);
+    socket.connectToHost(QtNetworkSettings::httpServerName(), 12346);
 
     QElapsedTimer timer;
     timer.start();
@@ -434,7 +437,11 @@ void tst_NetworkSelfTest::serverReachability()
 
 void tst_NetworkSelfTest::remotePortsOpen_data()
 {
+#if defined(QT_TEST_SERVER)
+    QSKIP("Skipping, for the docker test server already tested by initTestCase()");
+#endif
     QTest::addColumn<int>("portNumber");
+
     QTest::newRow("echo") << 7;
     QTest::newRow("daytime") << 13;
     QTest::newRow("ftp") << 21;
@@ -453,9 +460,10 @@ void tst_NetworkSelfTest::remotePortsOpen_data()
 
 void tst_NetworkSelfTest::remotePortsOpen()
 {
-    QFETCH(int, portNumber);
+    QFETCH(const int, portNumber);
+
     QTcpSocket socket;
-    socket.connectToHost(QtNetworkSettings::serverName(), portNumber);
+    socket.connectToHost(QtNetworkSettings::hostWithServiceOnPort(portNumber), quint16(portNumber));
 
     if (!socket.waitForConnected(10000)) {
         if (socket.error() == QAbstractSocket::SocketTimeoutError)
@@ -470,43 +478,43 @@ static QList<Chat> ftpChat(const QByteArray &userSuffix = QByteArray())
 {
     QList<Chat> rv;
     rv << Chat::expect("220")
-            << Chat::discardUntil("\r\n")
-            << Chat::send("USER anonymous" + userSuffix + "\r\n")
-            << Chat::expect("331")
-            << Chat::discardUntil("\r\n")
-            << Chat::send("PASS user@hostname\r\n")
-            << Chat::expect("230")
-            << Chat::discardUntil("\r\n")
-
-            << Chat::send("CWD pub\r\n")
-            << Chat::expect("250")
-            << Chat::discardUntil("\r\n")
-            << Chat::send("CWD dir-not-readable\r\n")
-            << Chat::expect("550")
-            << Chat::discardUntil("\r\n")
-            << Chat::send("PWD\r\n")
-            << Chat::expect("257 \"/pub\"\r\n")
-            << Chat::send("SIZE file-not-readable.txt\r\n")
-            << Chat::expect("213 41\r\n")
-            << Chat::send("CWD qxmlquery\r\n")
-            << Chat::expect("250")
-            << Chat::discardUntil("\r\n")
-
-            << Chat::send("CWD /qtest\r\n")
-            << Chat::expect("250")
-            << Chat::discardUntil("\r\n")
-            << Chat::send("SIZE bigfile\r\n")
-            << Chat::expect("213 519240\r\n")
-            << Chat::send("SIZE rfc3252\r\n")
-            << Chat::expect("213 25962\r\n")
-            << Chat::send("SIZE rfc3252.txt\r\n")
-            << Chat::expect("213 25962\r\n")
-//            << Chat::send("SIZE nonASCII/german_\344\366\374\304\326\334\337\r\n")
-//            << Chat::expect("213 40\r\n")
-
-            << Chat::send("QUIT\r\n");
-        rv  << Chat::expect("221")
-            << Chat::discardUntil("\r\n");
+       << Chat::discardUntil("\r\n")
+       << Chat::send("USER anonymous" + userSuffix + "\r\n")
+       << Chat::expect("331")
+       << Chat::discardUntil("\r\n")
+       << Chat::send("PASS user@hostname\r\n")
+       << Chat::expect("230")
+       << Chat::discardUntil("\r\n")
+       << Chat::send("CWD pub\r\n")
+       << Chat::expect("250")
+       << Chat::discardUntil("\r\n")
+       << Chat::send("CWD dir-not-readable\r\n")
+       << Chat::expect("550")
+       << Chat::discardUntil("\r\n")
+       << Chat::send("PWD\r\n")
+#if defined(QT_TEST_SERVER)
+       << Chat::expect("257 \"/pub\" is the current directory\r\n")
+#else
+       << Chat::expect("257 \"/pub\"\r\n")
+#endif
+       << Chat::send("SIZE file-not-readable.txt\r\n")
+       << Chat::expect("213 41\r\n")
+       << Chat::send("CWD qxmlquery\r\n")
+       << Chat::expect("250")
+       << Chat::discardUntil("\r\n")
+       << Chat::send("CWD /qtest\r\n")
+       << Chat::expect("250")
+       << Chat::discardUntil("\r\n")
+       << Chat::send("SIZE bigfile\r\n")
+       << Chat::expect("213 519240\r\n")
+       << Chat::send("SIZE rfc3252\r\n")
+       << Chat::expect("213 25962\r\n")
+       << Chat::send("SIZE rfc3252.txt\r\n")
+       << Chat::expect("213 25962\r\n")
+       << Chat::send("QUIT\r\n");
+
+    rv << Chat::expect("221")
+       << Chat::discardUntil("\r\n");
 
     rv << Chat::RemoteDisconnect;
     return rv;
@@ -519,7 +527,7 @@ void tst_NetworkSelfTest::ftpServer()
 
 void tst_NetworkSelfTest::ftpProxyServer()
 {
-    netChat(2121, ftpChat("@" + QtNetworkSettings::serverName().toLatin1()));
+    netChat(2121, ftpChat("@" + QtNetworkSettings::ftpServerName().toLatin1()));
 }
 
 void tst_NetworkSelfTest::imapServer()
@@ -551,7 +559,7 @@ void tst_NetworkSelfTest::httpServer()
             // HTTP/1.0 chat:
             << Chat::Reconnect
             << Chat::send("GET / HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Connection: close\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
@@ -563,7 +571,7 @@ void tst_NetworkSelfTest::httpServer()
             << Chat::Reconnect
             << Chat::send("POST / HTTP/1.0\r\n"
                           "Content-Length: 5\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Connection: close\r\n"
                           "\r\n"
                           "Hello")
@@ -575,7 +583,7 @@ void tst_NetworkSelfTest::httpServer()
             // HTTP protected area
             << Chat::Reconnect
             << Chat::send("GET /qtest/protected/rfc3252.txt HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Connection: close\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
@@ -585,7 +593,7 @@ void tst_NetworkSelfTest::httpServer()
 
             << Chat::Reconnect
             << Chat::send("HEAD /qtest/protected/rfc3252.txt HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Connection: close\r\n"
                           "Authorization: Basic cXNvY2tzdGVzdDpwYXNzd29yZA==\r\n"
                           "\r\n")
@@ -597,7 +605,7 @@ void tst_NetworkSelfTest::httpServer()
             // DAV area
             << Chat::Reconnect
             << Chat::send("HEAD /dav/ HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Connection: close\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
@@ -609,7 +617,7 @@ void tst_NetworkSelfTest::httpServer()
             << Chat::Reconnect
             << Chat::send("PUT /dav/networkselftest-" + uniqueExtension + ".txt HTTP/1.0\r\n"
                           "Content-Length: 5\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Connection: close\r\n"
                           "\r\n"
                           "Hello")
@@ -621,7 +629,7 @@ void tst_NetworkSelfTest::httpServer()
             // check that the file did get uploaded
             << Chat::Reconnect
             << Chat::send("HEAD /dav/networkselftest-" + uniqueExtension + ".txt HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Connection: close\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
@@ -633,7 +641,7 @@ void tst_NetworkSelfTest::httpServer()
             // HTTP/1.0 DELETE
             << Chat::Reconnect
             << Chat::send("DELETE /dav/networkselftest-" + uniqueExtension + ".txt HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Connection: close\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
@@ -668,7 +676,7 @@ void tst_NetworkSelfTest::httpServerFiles()
 
     QList<Chat> chat;
     chat << Chat::send("HEAD " + url.toEncoded() + " HTTP/1.0\r\n"
-                       "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                       "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                        "Connection: close\r\n"
                        "Authorization: Basic cXNvY2tzdGVzdDpwYXNzd29yZA==\r\n"
                        "\r\n")
@@ -757,7 +765,7 @@ void tst_NetworkSelfTest::httpsServer()
     netChat(443, QList<Chat>()
             << Chat::StartEncryption
             << Chat::send("GET / HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Connection: close\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
@@ -772,7 +780,7 @@ void tst_NetworkSelfTest::httpProxy()
     netChat(3128, QList<Chat>()
             // proxy GET by IP
             << Chat::send("GET http://" + serverIpAddress().toString().toLatin1() + "/ HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Proxy-connection: close\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
@@ -782,8 +790,8 @@ void tst_NetworkSelfTest::httpProxy()
 
             // proxy GET by hostname
             << Chat::Reconnect
-            << Chat::send("GET http://" + QtNetworkSettings::serverName().toLatin1() + "/ HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+            << Chat::send("GET http://" + QtNetworkSettings::httpServerName().toLatin1() + "/ HTTP/1.0\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Proxy-connection: close\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
@@ -793,8 +801,13 @@ void tst_NetworkSelfTest::httpProxy()
 
             // proxy CONNECT by IP
             << Chat::Reconnect
+#if !defined(QT_TEST_SERVER)
             << Chat::send("CONNECT " + serverIpAddress().toString().toLatin1() + ":21 HTTP/1.0\r\n"
                           "\r\n")
+#else
+            << Chat::send("CONNECT " + ftpServerIpAddress.toString().toLatin1() + ":21 HTTP/1.0\r\n"
+                          "\r\n")
+#endif
             << Chat::expect("HTTP/1.")
             << Chat::discardUntil(" ")
             << Chat::expect("200 ")
@@ -803,7 +816,7 @@ void tst_NetworkSelfTest::httpProxy()
 
             // proxy CONNECT by hostname
             << Chat::Reconnect
-            << Chat::send("CONNECT " + QtNetworkSettings::serverName().toLatin1() + ":21 HTTP/1.0\r\n"
+            << Chat::send("CONNECT " + QtNetworkSettings::ftpServerName().toLatin1() + ":21 HTTP/1.0\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
             << Chat::discardUntil(" ")
@@ -817,8 +830,8 @@ void tst_NetworkSelfTest::httpProxyBasicAuth()
 {
     netChat(3129, QList<Chat>()
             // test auth required response
-            << Chat::send("GET http://" + QtNetworkSettings::serverName().toLatin1() + "/ HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+            << Chat::send("GET http://" + QtNetworkSettings::httpServerName().toLatin1() + "/ HTTP/1.0\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Proxy-connection: close\r\n"
                           "\r\n")
             << Chat::expect("HTTP/1.")
@@ -829,8 +842,8 @@ void tst_NetworkSelfTest::httpProxyBasicAuth()
 
             // now try sending our credentials
             << Chat::Reconnect
-            << Chat::send("GET http://" + QtNetworkSettings::serverName().toLatin1() + "/ HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+            << Chat::send("GET http://" + QtNetworkSettings::httpServerName().toLatin1() + "/ HTTP/1.0\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
                           "Proxy-connection: close\r\n"
                           "Proxy-Authorization: Basic cXNvY2tzdGVzdDpwYXNzd29yZA==\r\n"
                           "\r\n")
@@ -844,9 +857,13 @@ void tst_NetworkSelfTest::httpProxyNtlmAuth()
 {
     netChat(3130, QList<Chat>()
             // test auth required response
-            << Chat::send("GET http://" + QtNetworkSettings::serverName().toLatin1() + "/ HTTP/1.0\r\n"
-                          "Host: " + QtNetworkSettings::serverName().toLatin1() + "\r\n"
+            << Chat::send("GET http://" + QtNetworkSettings::httpServerName().toLatin1() + "/ HTTP/1.0\r\n"
+                          "Host: " + QtNetworkSettings::httpServerName().toLatin1() + "\r\n"
+#if !defined(QT_TEST_SERVER)
                           "Proxy-connection: keep-alive\r\n" // NTLM auth will disconnect
+#else
+                          "Proxy-connection: close\r\n" // Well, what do you know? It keeps it alive!
+#endif
                           "\r\n")
             << Chat::expect("HTTP/1.")
             << Chat::discardUntil(" ")
@@ -877,8 +894,12 @@ void tst_NetworkSelfTest::socks5Proxy()
         char buf[4];
         quint32 data;
     } ip4Address;
-    ip4Address.data = qToBigEndian(serverIpAddress().toIPv4Address());
-
+    ip4Address.data =
+#if !defined(QT_TEST_SERVER)
+    qToBigEndian(serverIpAddress().toIPv4Address());
+#else
+    qToBigEndian(ftpServerIpAddress.toIPv4Address());
+#endif
     const QByteArray handshakeNoAuthData = QByteArray(handshakeNoAuth, int(sizeof handshakeNoAuth) - 1);
     const QByteArray handshakeOkNoAuthData = QByteArray(handshakeOkNoAuth, int(sizeof handshakeOkNoAuth) - 1);
     const QByteArray connect1Data = QByteArray(connect1, int(sizeof connect1) - 1);
@@ -887,6 +908,10 @@ void tst_NetworkSelfTest::socks5Proxy()
 
     netChat(1080, QList<Chat>()
             // IP address connection
+#if !defined(QT_TEST_SERVER)
+            // This test relies on the proxy and ftp servers
+            // running on the same machine, which is not the
+            // case for the docker test server.
             << Chat::send(handshakeNoAuthData)
             << Chat::expect(handshakeOkNoAuthData)
             << Chat::send(connect1Data)
@@ -897,6 +922,7 @@ void tst_NetworkSelfTest::socks5Proxy()
 
             // connect by IP
             << Chat::Reconnect
+#endif
             << Chat::send(handshakeNoAuthData)
             << Chat::expect(handshakeOkNoAuthData)
             << Chat::send(QBA(connect1a) + QByteArray::fromRawData(ip4Address.buf, 4) + QBA(connect1b))
@@ -904,8 +930,9 @@ void tst_NetworkSelfTest::socks5Proxy()
             << Chat::expect("\1") // IPv4 address following
             << Chat::skipBytes(6) // the server's local address and port
             << ftpChat()
-
-            // connect to "localhost" by hostname
+#if !defined(QT_TEST_SERVER)
+            // connect to "localhost" by hostname, the same as above:
+            // makes no sense with the docker test server.
             << Chat::Reconnect
             << Chat::send(handshakeNoAuthData)
             << Chat::expect(handshakeOkNoAuthData)
@@ -914,12 +941,12 @@ void tst_NetworkSelfTest::socks5Proxy()
             << Chat::expect("\1") // IPv4 address following
             << Chat::skipBytes(6) // the server's local address and port
             << ftpChat()
-
+#endif
             // connect to server by its official name
             << Chat::Reconnect
             << Chat::send(handshakeNoAuthData)
             << Chat::expect(handshakeOkNoAuthData)
-            << Chat::send(QBA(connect2a) + char(QtNetworkSettings::serverName().size()) + QtNetworkSettings::serverName().toLatin1() + QBA(connect1b))
+            << Chat::send(QBA(connect2a) + char(QtNetworkSettings::ftpServerName().size()) + QtNetworkSettings::ftpServerName().toLatin1() + QBA(connect1b))
             << Chat::expect(connectedData)
             << Chat::expect("\1") // IPv4 address following
             << Chat::skipBytes(6) // the server's local address and port
@@ -941,8 +968,10 @@ void tst_NetworkSelfTest::socks5ProxyAuth()
             << Chat::send(handshakeNoAuthData)
             << Chat::expect(handshakeAuthNotOkData)
             << Chat::RemoteDisconnect
-
-            // now try to connect with authentication
+#if !defined(QT_TEST_SERVER)
+            // now try to connect with authentication,
+            // danted is just that, socks 5 proxy and
+            // does not have ftp running, skip!
             << Chat::Reconnect
             << Chat::send(handshakeAuthPasswordData)
             << Chat::expect(handshakeOkPasswdAuthData)
@@ -951,6 +980,16 @@ void tst_NetworkSelfTest::socks5ProxyAuth()
             << Chat::expect("\1") // IPv4 address following
             << Chat::skipBytes(6) // the server's local address and port
             << ftpChat()
+#else
+            << Chat::Reconnect
+            << Chat::send(handshakeAuthPasswordData)
+            << Chat::expect(handshakeOkPasswdAuthData)
+            << Chat::send(QBA(connect2a) + char(QtNetworkSettings::ftpServerName().size()) + QtNetworkSettings::ftpServerName().toLatin1() + QBA(connect1b))
+            << Chat::expect(connectedData)
+            << Chat::expect("\1") // IPv4 address following
+            << Chat::skipBytes(6) // the server's local address and port
+            << ftpChat()
+#endif
             );
 }
 
@@ -984,6 +1023,9 @@ static void ensureTermination(QProcess &process)
 
 void tst_NetworkSelfTest::smbServer()
 {
+#if defined(QT_TEST_SERVER)
+    QSKIP("Not supported by the docker test server");
+#endif // QT_TEST_SERVER
     static const char contents[] = "This is 34 bytes. Do not change...";
 #ifdef Q_OS_WIN
     // use Windows's native UNC support to try and open a file on the server
diff --git a/tests/testserver/apache2/testdata/main.conf b/tests/testserver/apache2/testdata/main.conf
index f3b13bb571..ed9aae3fbd 100644
--- a/tests/testserver/apache2/testdata/main.conf
+++ b/tests/testserver/apache2/testdata/main.conf
@@ -54,3 +54,7 @@ Alias /qtest "/home/qt-test-server/www/htdocs/"
 <Directory "/home/qt-test-server/www/htdocs/protected/">
     AllowOverride AuthConfig Options
 </Directory>
+
+<Directory /home/writeables/dav>
+    Options Indexes
+</Directory>
diff --git a/tests/testserver/apache2/testdata/www/htdocs/qxmlquery/viaHttp.xq b/tests/testserver/apache2/testdata/www/htdocs/qxmlquery/viaHttp.xq
new file mode 100644
index 0000000000..106072a44c
--- /dev/null
+++ b/tests/testserver/apache2/testdata/www/htdocs/qxmlquery/viaHttp.xq
@@ -0,0 +1 @@
+concat("This was ", "received via HTTP.")
diff --git a/tests/testserver/vsftpd/testdata/ftp/pub/qxmlquery/README b/tests/testserver/vsftpd/testdata/ftp/pub/qxmlquery/README
new file mode 100644
index 0000000000..0f4a679502
--- /dev/null
+++ b/tests/testserver/vsftpd/testdata/ftp/pub/qxmlquery/README
@@ -0,0 +1 @@
+This directory contains data for the auto test for QXmlQuery, found in the Qt module QtXmlPatterns.
